# -*- coding: utf-8 -*-
"""
@author: Jose Manuel Martín Cabeza
"""

import StruPy2D as sp2

#----------------------------Edificio 2D residencial--------------------------------#

"""Nodos"""
p1 = sp2.Node(0,0)
p2 = sp2.Node(0,3)
p3 = sp2.Node(0,6)
p4 = sp2.Node(0,9)
p5 = sp2.Node(0,12)
p6 = sp2.Node(6,0)
p7 = sp2.Node(6,3)
p8 = sp2.Node(6,6)
p9 = sp2.Node(6,9)
p10 = sp2.Node(6,12)

"""Materiales y secciones"""
m1 = sp2.Material('acero',2.1e11,7850)
s1 = sp2.Section('HEB160simp',A=5430e-6,I=4984e-8,h=0.16)
#s1 = sp2.Section('HEB300simp',A=29820e-6,I=50340e-8,h=0.3)
m2 = sp2.Material('horm_armado',2.143e8,2500)
s2 = sp2.Section('forjado',A=1.5,I=1.125e-2,h=0.3)


"""Barras"""
b1 = sp2.Bar(1, p1, p2, m1, s1)
b2 = sp2.Bar(2, p2, p3, m1, s1)
b3 = sp2.Bar(3, p3, p4, m1, s1)
b4 = sp2.Bar(4, p4, p5, m1, s1)
b5 = sp2.Bar(5, p6, p7, m1, s1)
b6 = sp2.Bar(6, p7, p8, m1, s1)
b7 = sp2.Bar(7, p8, p9, m1, s1)
b8 = sp2.Bar(8, p9, p10, m1, s1)
b9 = sp2.Bar(9, p2, p7, m2, s2)
b10 = sp2.Bar(10, p3, p8, m2, s2)
b11 = sp2.Bar(11, p4, p9, m2, s2)
b12 = sp2.Bar(12, p5, p10, m2, s2)

"""Cargas"""
q1 = sp2.Load('q1','DIS',fy = -46750)

b9.addLoad(q1)
b10.addLoad(q1)
b11.addLoad(q1)
b12.addLoad(q1)

"""Condiciones de contorno"""
p1.setBC(sp2.CLAMPED)
p6.setBC(sp2.CLAMPED)

"""Generar estructura"""
S = sp2.Structure([b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12])
S.show()
S.setWeight('off')

"""Calculo estatico"""
St = sp2.Static(S, run=True)
St.show(escaleDef=50)
for B in St.bars:
    print(B)

"""Calculo pandeo global"""
for i in range(3):
    Bu = sp2.Buckling(St, run=True, verModo=i+1)
    Bu.show()
print(Bu)

