# -*- coding: utf-8 -*-
"""
Created on Mon Dec 11 20:07:26 2017

@author: Alvaro
"""

from StruPy2D.Graphics.BC import _BC as bc
from StruPy2D.Graphics.graphNode import graphNode as gN
from StruPy2D.Graphics.graphBar import graphBar as gB
from StruPy2D.Graphics.graphLoad import graphLoad as gL

from matplotlib.axes import Axes
from matplotlib.figure import Figure
import matplotlib.pyplot as plt

import numpy as np

class SPAxes(Axes):
    _nds = []
    _viewNodes = True
    _bars = []
    _viewBars = True
    
    _BC = []
    _loads = []
    
    _Static = None
    
    def __init__(self, *args, **kwargs):
        if(len(args) == 0):
            fig = plt.figure()
            Axes.__init__(self, fig, [0,0,1,1])
            fig.add_axes(self)
            
        elif(len(args) == 1):
            if(isinstance(args[0], Figure)):
                Axes.__init__(self, args[0], [0,0,1,1], **kwargs)
                args[0].add_axes(self)
                
            elif(isinstance(args[0], list)):
                try:
                    np.isfinite(args[0]).all()
                except TypeError as err:
                    err.args = ['Expected four numeric values when creating SPAxes']
                    raise err
                
                fig = plt.figure()
                Axes.__init__(self, fig, args[0], **kwargs)
                fig.add_axes(self)
            else:
                raise TypeError('First positional argument must be a Figure or a list')
                
        elif(len(args) == 2):
            if not isinstance(args[0], Figure):
                raise TypeError('First positional argument must be a Figure')
            if not isinstance(args[1], list):
                raise TypeError('Second positional argument must be a list')
            if(len(args[1]) != 4):
                raise ValueError('Second positional argument must be a 4 element list')
            
            try:
                np.isfinite(args[1]).all()
            except TypeError as err:
                err.args = ['Expected four numeric values']
                raise err
                
            Axes.__init__(self, args[0], args[1], **kwargs)
            args[0].add_axes(self)
            
        else:
            raise Exception('Too many positional input arguments.')
            
        plt.axis('equal')
        
    def addElement(self, elem):
        """Add a new graphic object to axes."""
        if(isinstance(elem,gN)):
            self._nds.append(elem)
            self.add_collection(elem)
            elem.ax = self
        
        if(isinstance(elem, gB)):
            self._bars.append(elem)
            self.add_collection(elem)
            elem.ax = self
            
        if(isinstance(elem,bc)):
            self._BC.append(elem)
            self.add_collection(elem)
            elem.ax = self
            
        if(isinstance(elem, gL)):
            self._loads.append(elem)
            self.add_collection(elem)
            elem.ax = self