# -*- coding: utf-8 -*-
"""
Created on Mon Jan 29 17:14:31 2018

@author: Álvaro
"""
from matplotlib.collections import PatchCollection
from matplotlib import patches as ptch
from matplotlib.path import Path as pth
from matplotlib.transforms import Affine2D

import numpy as np
from math import sin, cos, pi, sqrt, atan

class graphLoad(PatchCollection):
    def __init__(self, load, style, spaxes, *args, **kwargs):
        patches = [] # Aquí van a ir los parches que representan la carga
        
        self.load = load
        self.ax = None
        
        if(load.type == 'NOD'):
            self.nodes = load.nodes
            self.bars = []
            
            F = sqrt(load.fx**2 + load.fy**2)
            # thF es el ángulo de la fuerza, en coord. nodales, entre -pi y pi.
            if(load.fx == 0):
                if(load.fy >= 0):
                    thF = pi/2
                else:
                    thF = -pi/2
            elif(load.fx > 0):
                thF = atan(load.fy/load.fx)

            else:
                thF = atan(load.fy/load.fx)
                #thF = thF - thF*np.sign(thF)
                #print(thF)

            for i in range(len(self.nodes)):
                node = self.nodes[i]
                grNode = spaxes._nds[i]
                # Ahora pasamos thF a coordenadas globales, entre -pi y pi
                thF = thF + node.th
                if(thF < -pi):
                    thF = thF + 2*pi
                elif(thF > pi):
                    thF = thF - 2*pi
                
                # A continuación se decide si se pinta heads or tails, en función del
                # ángulo que forman las barras que confluyen en el nudo
                head = 0
                tail = 0
                for B in node.bars:
                    thB = B.th if abs(B.th) <= pi else B.th - 2*pi*np.sign(B.th)
                    auxAngle = thB - thF
                    auxAngleH = pi - abs(thB - thF)
                    tail = tail + min(abs(auxAngle), 2*pi - abs(auxAngle))
                    head = head + min(abs(auxAngleH), 2*pi - abs(auxAngleH))
                
                # Determinamos la distancia al punto teórico al que estará
                dist = 1.02*grNode.b/sqrt(2)
                
                if(tail > head):
                    arr = ptch.FancyArrow(node.x + dist*cos(thF), 
                                          node.y + dist*sin(thF), 
                                          style.dim*cos(thF), 
                                          style.dim*sin(thF), 
                                          width = 0.1*style.dim,
                                          head_length = 0.36*style.dim,
                                          length_includes_head = True)
                else:
                    arr = ptch.FancyArrow(node.x - dist*cos(thF) - style.dim*cos(thF), 
                                          node.y - dist*sin(thF) - style.dim*sin(thF), 
                                          style.dim*cos(thF), 
                                          style.dim*sin(thF), 
                                          width = 0.1*style.dim,
                                          head_length = 0.36*style.dim,
                                          length_includes_head = True)
                    
                patches.append(arr)
                
        elif(load.type == 'PUN'):
            pass
        elif(load.type == 'DIS'):
            pass
        elif(load.type == 'TER_L'):
            pass
        elif(load.type == 'TER_T'):
            pass
        elif(load.type == 'DEF'):
            pass

        PatchCollection.__init__(self, patches, *args, **kwargs,
                        edgecolors = style.EdgeColor1, facecolors = style.FaceColor1,
                        zorder = 4)
        self.set_visible(style.visible)