# -*- coding: utf-8 -*-
"""
Created on Tue Jan 30 19:17:44 2018

@author: Alvaro
"""

from matplotlib.collections import PatchCollection
from matplotlib import patches as ptch
from matplotlib.path import Path as pth
from matplotlib.transforms import Affine2D

import numpy as np
from math import sin, cos, pi

class graphNode(PatchCollection):
    def __init__(self, node, style, *args, **kwargs):
        self.node = node
        self.ax = None
        
        if(style.auto_scale):
            b = 0
            for B in node.bars:
                b = max(b, 1.5*B.sec.h)
        else:
            b = style.dim
            
        x = node.x - 0.5*b*cos(node.th) + 0.5*b*sin(node.th)
        y = node.y - 0.5*b*cos(node.th) - 0.5*b*sin(node.th)
        patch = ptch.Rectangle((x, y), b, b)
        
        self.b = b # Guardamos el tamaño de lado del rectángulo
        
        PatchCollection.__init__(self, [patch], *args, **kwargs,
                        edgecolors = style.EdgeColor1, facecolors = style.FaceColor1,
                        zorder = 2)
        self.set_visible(style.visible)