# -*- coding: utf-8 -*-
"""
Created on Wed Aug 30 19:43:01 2017

@author: Alvaro Magdaleno Gonzalez
"""

class Section:
    def __init__(self,name,A=0,I=0,h=0):
        self.ID = name
        self.setProps(A,I,h)
        
    def __str__(self):
        return 'ID: {}\r\nA = {:.3e}, I = {:.3e}, h = {:.3e}'.format(self.ID,self.A,self.I,self.h)
    
    def __repr__(self):
        return 'ID: {}\r\nA = {:.3e}, I = {:.3e}, h = {:.3e}'.format(self.ID,self.A,self.I,self.h)
    
    def setProps(self,A=0,I=0,h=0):
        try:
            self.A = A
            self.I = I
            self.h = h
        except TypeError as err:
            err.args = ('Expected numeric values for Section properties; ' + err.args[0],)
            raise
            
    def rename(self,name):
        self.ID = name
        
    def applyTo(self,b):
        """Aplica esta sección a la barra o barras indicadas (como lista)"""
        if(type(b).__name__ == "Bar"):
            b.sec = self
            b.getGlobal()
        elif(type(b).__name__ == "list"):
            for bar in b:
                if(type(bar).__name__ == 'Bar'):
                    bar.sec = self
                    bar.getGlobal()
                else:
                    raise TypeError("Sections can only be applied to Bar objects")
        else:
            raise TypeError("Sections can only be applied to Bar objects")
            
defSec = Section('default',1e-3,1e-6,0.2)

class SecList(list):
    def __init__(self,secs=[]):
        if(type(secs).__name__ in ['Section','list','SecList']):
            list.__init__(self,secs)
            
    def __repr__(self):
        return ',\n'.join([repr(a) for a in self])
    
    def __str__(self):
        return ',\n'.join([repr(a) for a in self])
        
    def A(self):
        return [I.A for I in self]
    
    def I(self):
        return [I.I for I in self]
    
    def h(self):
        return [I.h for I in self]
    
    def has(self, sec):
        if(type(sec).__name__ == 'Material'):
            if(len(self) > 0):
                for L in self:
                    if(L.A == sec.A and L.I == sec.I and L.h == sec.h and L.ID == sec.ID):
                        return True
            else:
                return False
        else:
            print('Invalid type')
        
        return False