# -*- coding: utf-8 -*-
"""
Created on Thu Dec  7 15:20:09 2017

@author:  Alvaro Magdaleno Gonzalez
"""

import numpy as np
from math import sqrt, sin, cos, pi, atan
import matplotlib.pyplot as plt
import matplotlib.patches as patches 

from StruPy2D.Graphics import BC as bc

def drawBC(ax,N,L):
    th = N.th
    BC = N.bc
    """Muestra en pantalla el apoyo requerido."""
    if(not BC[0] and BC[1] and BC[2]):
        p = bc.Moving(N)
        ax.addElement(p)
        p.th = th + pi/2
        p.sc = L/sqrt(2)
        
    elif(BC[0] and not BC[1] and BC[2]):
        p = bc.Moving(N)
        ax.addElement(p)
        p.th = th
        p.sc = L/sqrt(2)
        
    elif(BC[0] and BC[1] and not BC[2]):
        p = bc.NoRotation(N)
        ax.addElement(p)
        p.th = th
        p.sc = L/sqrt(2)
        
    elif(not BC[0] and not BC[1] and BC[2]):
        p = bc.Fixed(N)
        ax.addElement(p)
        p.th = th
        p.sc = L/sqrt(2)
        
    elif(not BC[0] and BC[1] and not BC[2]):
        p = bc.MovClamped(N)
        ax.addElement(p)
        p.th = th + pi/2
        p.sc = L/sqrt(2)
        
    elif(BC[0] and not BC[1] and not BC[2]):
        p = bc.MovClamped(N)
        ax.addElement(p)
        p.th = th
        p.sc = L/sqrt(2)
        
    elif(not BC[0] and not BC[1] and not BC[2]):
        l = L/sqrt(2)
        p = bc.Clamped(N)
        ax.addElement(p)
        
        if(len(N.bars) == 0 or len(N.bars) == 0 > 2):
            p.th = th 
        elif(len(N.bars) == 1):
            if(N is N.bars[0].p1):
                p.th = th + N.bars[0].th - pi/2
            else:
                p.th = th + N.bars[0].th + pi/2
        elif(len(N.bars) == 2):
            TH = []
            for B in N.bars:
                if(N is B.p1):
                    TH.append(B.th + 2*pi*(B.th < 0))
                else:
                    TH.append(B.th + 2*pi*(B.th < 0) - pi)
            for i in range(len(TH)):
                if(TH[i] < 0):
                    TH[i] = TH[i] + 2*pi
            print(TH)
            
            if(abs(TH[1]-TH[0]) > pi):
                p.th = + pi/2 + 0.5*(TH[0] + TH[1])
            else:
                p.th = - pi/2 + 0.5*(TH[0] + TH[1])
            
        p.sc = l
        
        
def drawElasSup(ax,N,L):
    x = N.x
    y = N.y
    th = N.th
    K = N.k
    BC = N.bc
    """Muestra en pantalla el resorte que corresponde al vector K."""
    if(K[0] != 0 and BC[0]):
        a = L/5 # "Módulo" del resorte
        b = L/5 # "Ancho" del resorte
        ax.plot([x, 
                 x + a*cos(th), 
                 x + 1.25*a*cos(th) - 0.5*b*sin(th),
                 x + 1.75*a*cos(th) + 0.5*b*sin(th),
                 x + 2.25*a*cos(th) - 0.5*b*sin(th),
                 x + 2.75*a*cos(th) + 0.5*b*sin(th),
                 x + 3.25*a*cos(th) - 0.5*b*sin(th),
                 x + 3.75*a*cos(th) + 0.5*b*sin(th),
                 x + 4*a*cos(th), 
                 x + 5*a*cos(th)],
                [y,
                 y + a*sin(th),
                 y + 1.25*a*sin(th) + 0.5*b*cos(th),
                 y + 1.75*a*sin(th) - 0.5*b*cos(th),
                 y + 2.25*a*sin(th) + 0.5*b*cos(th),
                 y + 2.75*a*sin(th) - 0.5*b*cos(th),
                 y + 3.25*a*sin(th) + 0.5*b*cos(th),
                 y + 3.75*a*sin(th) - 0.5*b*cos(th),
                 y + 4*a*sin(th), 
                 y + 5*a*sin(th)], 'b', lw = 0.8)
        ax.plot([x + 5*a*cos(th) - 0.5*b*sin(th), 
                 x + 5*a*cos(th) + 0.5*b*sin(th)],
                [y + 5*a*sin(th) + 0.5*b*cos(th),
                 y + 5*a*sin(th) - 0.5*b*cos(th)], 'b', lw=1.5)
        
    if(K[1] != 0 and BC[1]):
        th = th - pi/2
        a = L/5 # "Módulo" del resorte
        b = L/5 # "Ancho" del resorte
        ax.plot([x, 
                 x + a*cos(th), 
                 x + 1.25*a*cos(th) - 0.5*b*sin(th),
                 x + 1.75*a*cos(th) + 0.5*b*sin(th),
                 x + 2.25*a*cos(th) - 0.5*b*sin(th),
                 x + 2.75*a*cos(th) + 0.5*b*sin(th),
                 x + 3.25*a*cos(th) - 0.5*b*sin(th),
                 x + 3.75*a*cos(th) + 0.5*b*sin(th),
                 x + 4*a*cos(th), 
                 x + 5*a*cos(th)],
                [y,
                 y + a*sin(th),
                 y + 1.25*a*sin(th) + 0.5*b*cos(th),
                 y + 1.75*a*sin(th) - 0.5*b*cos(th),
                 y + 2.25*a*sin(th) + 0.5*b*cos(th),
                 y + 2.75*a*sin(th) - 0.5*b*cos(th),
                 y + 3.25*a*sin(th) + 0.5*b*cos(th),
                 y + 3.75*a*sin(th) - 0.5*b*cos(th),
                 y + 4*a*sin(th), 
                 y + 5*a*sin(th)], 'b', lw = 0.8)
        ax.plot([x + 5*a*cos(th) - 0.5*b*sin(th), 
                 x + 5*a*cos(th) + 0.5*b*sin(th)],
                [y + 5*a*sin(th) + 0.5*b*cos(th),
                 y + 5*a*sin(th) - 0.5*b*cos(th)], 'b', lw=1.5)
        th = th + pi/2
        
    if(K[2] != 0 and BC[2]):
        TH = np.linspace(0,4*pi+pi/3,100)
        X = 0.025*L*TH*np.cos(TH+th)
        Y = 0.025*L*TH*np.sin(TH+th)
        
        ax.plot(x+X, y+Y, 'b', lw = 0.8)
        ax.plot([x + X[len(X)-1], 
                 x + X[len(X)-1] + 0.2*L*cos(th+pi/3)],
                 [y + Y[len(Y)-1], 
                  y + Y[len(Y)-1] + 0.2*L*sin(th+pi/3)], 'b', lw = 0.8)
        ax.plot([x + X[len(X)-1] + 0.2*L*cos(th+pi/3) - 0.1*L*sin(th+pi/3),
                 x + X[len(X)-1] + 0.2*L*cos(th+pi/3) + 0.1*L*sin(th+pi/3)],
                [y + Y[len(Y)-1] + 0.2*L*sin(th+pi/3) + 0.1*L*cos(th+pi/3),
                 y + Y[len(Y)-1] + 0.2*L*sin(th+pi/3) - 0.1*L*cos(th+pi/3)], 
                 'b', lw = 1.5)
        
def drawDispSup(ax,N,L):
    """Muestra en pantalla una flecha con la dirección de un desplazamiento prescrito."""
    x = N.x
    y = N.y
    th = N.th
    BC = N.bc
    if(N.u[0] != 0 and not BC[0]):
        if(not BC[1] and BC[2]):
            a = 1
        elif(not BC[1] and not BC[2]):
            a = 0.6
        else:
            a = 0.5

        p = patches.Arrow(x + a*L*sin(th) - 0.45*L*cos(th)*np.sign(N.u[0]),
                          y - a*L*cos(th) - 0.45*L*sin(th)*np.sign(N.u[0]),
                          0.95*L*cos(th)*np.sign(N.u[0]),
                          0.95*L*sin(th)*np.sign(N.u[0]),
                          width=0.33*L,
                          zorder = 3)
        ax.add_patch(p)
        
    if(N.u[1] != 0 and not BC[1]):
        if(not BC[1] and BC[2]):
            a = 1.05
        elif(not BC[1] and not BC[2]):
            a = 0.65
        else:
            a = 0.55

        p = patches.Arrow(x + (a+0.90*(N.u[1]>0))*L*sin(th),
                          y - (a+0.90*(N.u[1]>0))*L*cos(th),
                          0.90*L*sin(th)*np.sign(N.u[1]),
                          0.90*L*cos(th)*np.sign(N.u[1]),
                          width=0.33*L,
                          zorder = 3)
        ax.add_patch(p)
    
    if(N.u[2] != 0 and not BC[2]):
        if(N.u[2] > 0):
            p = patches.FancyArrowPatch(
                    (x - 0.5*L, y - 0.866*L),
                    (x + 0.5*L, y - 0.866*L),
                    connectionstyle = 'arc3, rad=0.5',
                    mutation_scale = 15,
                    color = '#1f77b4',
                    lw = 0.1)
        else:
            p = patches.FancyArrowPatch(
                    (x + 0.5*L, y - 0.866*L),
                    (x - 0.5*L, y - 0.866*L),
                    connectionstyle = 'arc3, rad=-0.5',
                    mutation_scale = 15,
                    color = '#1f77b4',
                    lw = 0.1)
        ax.add_patch(p)