# -*- coding: utf-8 -*-
"""
@author: Jose Manuel Martín Cabeza
"""

import StruPy2D as sp2

#---------------------------Viga continua caso 4-------------------------------#

"""Nodos"""
p1 = sp2.Node(0,0)
p112 = sp2.Node(1.25,0)
p12 = sp2.Node(2.5,0)
p122 = sp2.Node(3.75,0)
p2 = sp2.Node(5,0)
p223 = sp2.Node(6.25,0)
p23 = sp2.Node(7.5,0)
p233 = sp2.Node(8.75,0)
p3 = sp2.Node(10,0)
p334 = sp2.Node(11.25,0)
p34 = sp2.Node(12.5,0)
p344 = sp2.Node(13.75,0)
p4 = sp2.Node(15,0)

"""Materiales y secciones"""
m1 = sp2.Material('acero',2.1e11,7850)
s1 = sp2.Section('sec1',A=20e-3,I=220e-6,h=0.4)

"""Barras"""
b1 = sp2.Bar(1, p1, p112, m1, s1)
b2 = sp2.Bar(2, p112, p12, m1, s1)
b3 = sp2.Bar(3, p12, p122, m1, s1)
b4 = sp2.Bar(4, p122, p2, m1, s1)
b5 = sp2.Bar(5, p2, p223, m1, s1)
b6 = sp2.Bar(6, p223, p23, m1, s1)
b7 = sp2.Bar(7, p23, p233, m1, s1)
b8 = sp2.Bar(8, p233, p3, m1, s1)
b9 = sp2.Bar(9, p3, p334, m1, s1)
b10 = sp2.Bar(10, p334, p34, m1, s1)
b11 = sp2.Bar(11, p34, p344, m1, s1)
b12 = sp2.Bar(12, p344, p4, m1, s1)

"""Cargas"""
f1 = sp2.Load('f1','NOD',fx=-10000)
p4.addLoad(f1)

"""Condiciones de contorno"""
p1.setBC(sp2.CLAMPED)
p2.setBC(sp2.H_MOVING)
p4.setBC(sp2.H_MOVING)

"""Generar estructura"""
S = sp2.Structure([b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12])
S.show()
S.setWeight('off')

"""Calculo estatico"""
St = sp2.Static(S, run=True)
for B in St.bars:
    print(B)

"""Calculo pandeo global"""    
Bu = sp2.Buckling(St, run=True, verModo=1)
Bu.show()
print(Bu)
